/*--------------------------------------------------------------------------+
$Id: codetemplates.xml 1 2011-01-01 00:00:01Z hoelzl $
|                                                                          |
| Copyright 2017 fortiss GmbH                     |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.platform.raspberry.compose;

import static org.conqat.lib.commons.reflect.ReflectionUtils.isInstanceOfAny;

import org.eclipse.emf.ecore.EObject;
import org.fortiss.af3.platform.compose.PlatformArchitectureElementCompositorBase;
import org.fortiss.af3.platform.model.IPlatformArchitectureElement;
import org.fortiss.af3.platform.raspberry.model.ActuatorConnector;
import org.fortiss.af3.platform.raspberry.model.ActuatorPWM;
import org.fortiss.af3.platform.raspberry.model.CanConnector;
import org.fortiss.af3.platform.raspberry.model.RaspberryPi;
import org.fortiss.af3.platform.raspberry.model.SensorConnector;
import org.fortiss.af3.platform.raspberry.model.SensorGamepad;
import org.fortiss.af3.platform.raspberry.model.SensorIMU;
import org.fortiss.af3.platform.raspberry.model.SensorLaserRangeFinder;
import org.fortiss.af3.platform.raspberry.model.SensorLaserScanner;

/**
 * 
 * @author eder
 * @author $Author: hoelzl $
 * @version $Rev: 18709 $
 * @ConQAT.Rating RED Hash:
 */
public class RaspberryPiCompositor extends
		PlatformArchitectureElementCompositorBase<IPlatformArchitectureElement> {

	/** {@inheritDoc} */
	@Override
	protected boolean isCorrectElementClass(IPlatformArchitectureElement container,
			EObject contained) {
		final boolean instanceOfAny2 =
				isInstanceOfAny(contained, CanConnector.class, SensorConnector.class,
						ActuatorConnector.class, ActuatorPWM.class, SensorLaserRangeFinder.class,
						SensorGamepad.class, SensorLaserScanner.class, SensorIMU.class);
		if(container != null) {
			final boolean instanceOfAny = isInstanceOfAny(container, RaspberryPi.class);
			return instanceOfAny && instanceOfAny2;
		}
		return instanceOfAny2;
	}

}
